﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class CartaoForm : Form
    {
        public CartaoForm()
        {
            InitializeComponent();
        }

        private void btnCartaoInserir_Click(object sender, EventArgs e)
        {
            //
            // mostar UI para actualizar os dados
            //
            CartaoInserirForm cartaoinserir = new CartaoInserirForm(0);
            if (cartaoinserir.ShowDialog() == DialogResult.OK)
            {
                //
                // actualizar os dados
                //
                DataRow r = cartaoinserir.Cartao;
                PhonicsStatusEnum st,stt;
                ICartao c = Fabrica.CreateCartaoService();
                IUtilizador u = Fabrica.CreateUtilizadorService();
                int id = c.Inserir(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, cartaoinserir.TarifarioID, cartaoinserir.ClienteID, int.Parse(r["numero"].ToString()), cartaoinserir.Tipo, float.Parse(r["saldo"].ToString()), out st);
                stt = u.ActualizarComissao(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, cartaoinserir.Comissao);
                if (st != PhonicsStatusEnum.OK)
                    MessageBox.Show("Aconteceu um problema ao actualizar a BD", "PhonicsWindowsApplication", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void btnCartaoUpdate_Click(object sender, EventArgs e)
        {
            if (dgCartao.DataSource != null)
            {
                //
                // obter registo seleccionado na datagrid
                //

                //Get the Currency Manager by using the BindingContext of the DataGrid
                CurrencyManager cm = (CurrencyManager)this.BindingContext[dgCartao.DataSource, dgCartao.DataMember];

                //Retrieve the default DataView of the DataGrid
                DataView dv = (DataView)cm.List;

                // Use Currency Manager and DataView to retrieve the Current Row
                DataRow dr = dv[cm.Position].Row;

                //
                // mostar UI para actualizar os dados
                //
                CartaoInserirForm cartaoinserir = new CartaoInserirForm(1);
                cartaoinserir.Cartao = dr;
                if (cartaoinserir.ShowDialog() == DialogResult.OK)
                {
                    //
                    // actualizar os dados
                    //
                    DataRow r = cartaoinserir.Cartao;

                    ICartao c = Fabrica.CreateCartaoService();
                    PhonicsStatusEnum st = c.Update(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, (int)r["CartaoID"], (int)r["clienteID"], (int)r["tarifarioID"], int.Parse(r["numero"].ToString()), r["tipo"].ToString());
                    if (st != PhonicsStatusEnum.OK)
                        MessageBox.Show("Aconteceu um problema ao actualizar a BD: " + st, "Phonics", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void btnProcurar_Click(object sender, EventArgs e)
        {
            ActualizarDataGridCartao(-1, null);
        }

        private void ActualizarDataGridCartao(int cartaoIDaSelecionar, string filtro)
        {
            if (filtro != null)
                txtNumero.Text = filtro;
            else
            {
                if (txtNumero.Text.Trim().Length == 0)
                    txtNumero.Text = "%";
            }

            //
            // procurar os clientes
            //
            ICartao c = Fabrica.CreateCartaoService();
            DataSet ds = c.GetInfoByNumero(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, txtNumero.Text);

            //
            // efectuar databind
            //
            dgCartao.DataMember = "Cartao";
            dgCartao.DataSource = ds;

            //
            // seleccionar a linha que contém o cartao pedido
            //
            if (cartaoIDaSelecionar > 0)
            {
                //Get the Currency Manager by using the BindingContext of the DataGrid
                CurrencyManager cm = (CurrencyManager)this.BindingContext[dgCartao.DataSource, dgCartao.DataMember];

                //Retrieve the default DataView of the DataGrid
                DataView dv = (DataView)cm.List;

                string oldSortExpr = dv.Sort;
                dv.Sort = "CartaoID";
                int idx = dv.Find(cartaoIDaSelecionar);
                dv.Sort = oldSortExpr;
            }

        }

        private void bntCartaoCancelar_Click(object sender, EventArgs e)
        {

            if (dgCartao.DataSource != null)
            {
                //
                // obter registo seleccionado na datagrid
                //

                //Get the Currency Manager by using the BindingContext of the DataGrid
                CurrencyManager cm = (CurrencyManager)this.BindingContext[dgCartao.DataSource, dgCartao.DataMember];

                //Retrieve the default DataView of the DataGrid
                DataView dv = (DataView)cm.List;

                // Use Currency Manager and DataView to retrieve the Current Row
                DataRow dr = dv[cm.Position].Row;

                //
                // mostar UI para actualizar os dados
                //
                CartaoInserirForm cartaoinserir = new CartaoInserirForm(0);
                cartaoinserir.Cartao = dr;
                
                    DataRow r = cartaoinserir.Cartao;

                    ICartao c = Fabrica.CreateCartaoService();
                    PhonicsStatusEnum st = c.Cancelar(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, (int)r["CartaoID"]);
                    ActualizarDataGridCartao(-1, null);  
                if (st != PhonicsStatusEnum.OK)
                        MessageBox.Show("Aconteceu um problema ao actualizar a BD: " + st, "Phonics", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    
            }

        }

        private void btnSair_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnCartaoCarregar_Click(object sender, EventArgs e)
        {
            if (dgCartao.DataSource != null)
            {
                //
                // obter registo seleccionado na datagrid
                //

                //Get the Currency Manager by using the BindingContext of the DataGrid
                CurrencyManager cm = (CurrencyManager)this.BindingContext[dgCartao.DataSource, dgCartao.DataMember];

                //Retrieve the default DataView of the DataGrid
                DataView dv = (DataView)cm.List;

                // Use Currency Manager and DataView to retrieve the Current Row
                DataRow dr = dv[cm.Position].Row;

                //
                // mostar UI para actualizar os dados
                //
                CartaoInserirForm cartaoinserir = new CartaoInserirForm(2);
                cartaoinserir.Cartao = dr;
                if (cartaoinserir.ShowDialog() == DialogResult.OK)
                {
                    //
                    // actualizar os dados
                    //
                    DataRow r = cartaoinserir.Cartao;
                 
                    ICartao c = Fabrica.CreateCartaoService();
                    PhonicsStatusEnum st = c.Carregar(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, (int)r["CartaoID"],float.Parse(r["saldo"].ToString()));
                    ActualizarDataGridCartao(-1, null);
                    if (st != PhonicsStatusEnum.OK)
                        MessageBox.Show("Aconteceu um problema ao actualizar a BD: " + st, "Phonics", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }


            }
        }

        private void CartaoForm_Load(object sender, EventArgs e)
        {
            btnCartaoUpdate.Enabled = false;
            btnCartaoCarregar.Enabled = false;
            bntCartaoCancelar.Enabled = false;
        }

       

        private void dgCartao_MouseClick(object sender, MouseEventArgs e)
        {
            btnCartaoUpdate.Enabled = true;
            btnCartaoCarregar.Enabled = true;
            bntCartaoCancelar.Enabled = true;
        }

       

    }
}