﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class CartaoInserirForm : Form
    {
        int opcao;

        public CartaoInserirForm(int op)
        {
            opcao =op;
            InitializeComponent();
        }

        private DataRow _cartao;
        public DataRow Cartao
        {
            set { _cartao = value; }
            get { return _cartao; }
        }

        public int _clienteID;
        public int ClienteID
        {
            set { _clienteID = value; }
            get { return _clienteID; }
        }

        public int _tarifarioID;
        public int TarifarioID
        {
            set { _tarifarioID = value; }
            get { return _tarifarioID; }
        }

        public string _tipo;
        public string Tipo
        {
            set { _tipo = value; }
            get { return _tipo; }
        }

        public int _comissao;
        public int Comissao
        {
            set { _comissao = value; }
            get { return _comissao; }
        }


       
        private void CartaoInserirForm_Load(object sender, EventArgs e)
        {
            if (_cartao == null)
            {
                ICartao c = Fabrica.CreateCartaoService();
                DataSet ds = c.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, -1);
                _cartao = ds.Tables[0].NewRow();

            }
            else
            {
                if (opcao == 1)//update
                {
                    this.Text = "Actualizar Cartão";
                    txtSaldo.Enabled = false;
                    txtClienteID.Enabled = false;
                    txtClienteNome.Enabled = false;
                    btnClienteIDPesquisar.Enabled = false;
                    txtTarifarioID.Text = (_cartao["TarifarioID"]).ToString();
                    txtClienteID.Text = (_cartao["ClienteID"]).ToString();
                    txtSaldo.Text = (_cartao["Saldo"]).ToString();
                    if ((_cartao["Tipo"].ToString().Equals("Carregamento")))
                        cbTipo.SelectedIndex = 0;
                    else
                        cbTipo.SelectedIndex = 1;
                    
                    
                }
                else
                    if (opcao == 2)//carregamento
                    {
                        this.Text = "Carregar Cartão";
                        txtClienteID.Enabled = false;
                        txtClienteNome.Enabled = false;
                        btnClienteIDPesquisar.Enabled = false;
                        txtTarifarioDescricao.Enabled = false;
                        txtTarifarioID.Enabled = false;
                        btnTarifarioIDPesquisar.Enabled = false;
                        cbTipo.Enabled = false;
                        txtNumero.Enabled = false;
                        lbSaldo.Text = "Valor";                               
                    }
               txtNumero.Text = _cartao["numero"].ToString();
                
                
                
            }
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
           if(opcao==0)//inserir
            {
                 _cartao["numero"] = txtNumero.Text.Trim();
                 _cartao["saldo"] = float.Parse(txtSaldo.Text);
                 _clienteID = int.Parse(txtClienteID.Text);
                 _tarifarioID = int.Parse(txtTarifarioID.Text);
                 _tipo = cbTipo.SelectedItem.ToString();
            }
            else
            if(opcao==1)//update
            {
                _cartao["numero"] = txtNumero.Text.Trim();
                _cartao["saldo"] = float.Parse(txtSaldo.Text);
                _clienteID = int.Parse(txtClienteID.Text);
                _tarifarioID = int.Parse(txtTarifarioID.Text);
                _tipo = cbTipo.SelectedItem.ToString();
            }
            else
                if (opcao == 2)//carregamento
                {
                    _cartao["numero"] = txtNumero.Text.Trim();
                    _cartao["saldo"] = (float.Parse(_cartao["saldo"].ToString())) + (float.Parse(txtSaldo.Text));
                }
          this.DialogResult = DialogResult.OK;
        }

        private void btnClienteIDPesquisar_Click(object sender, EventArgs e)
        {
            //
            // pesquisar pelo código introduzido 
            //
            ICliente c = Fabrica.CreateClienteService();
            DataSet ds = null;
            try
            {
                ds = c.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, int.Parse(txtClienteID.Text));
            }
            catch (FormatException /* ex */)
            {
                ds = null;
            }
            if (ds == null || ds.Tables["Cliente"].Rows.Count == 0)
            {
                txtClienteNome.Text = "";

                //
                // mostrar janela de pesquisa
                //
                ClientePesquisaForm cp = new ClientePesquisaForm();
                if (cp.ShowDialog() == DialogResult.OK)
                {
                    ds = c.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, cp.ClienteID);
                    txtClienteNome.Text = (string)ds.Tables["Cliente"].Rows[0]["Nome"];
                    txtClienteID.Text = cp.ClienteID.ToString();
                }
            }
            else
            {
                //
                // mostrar nome do cliente
                //
                txtClienteNome.Text = (string)ds.Tables["Cliente"].Rows[0]["Nome"];

            }		
        }

        private void btnTarifarioIDPesquisar_Click(object sender, EventArgs e)
        {
            //
            // pesquisar pelo código introduzido 
            //
            ITarifario t = Fabrica.CreateTarifarioService();
            DataSet ds = null;
            try
            {
                ds = t.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, int.Parse(txtTarifarioID.Text));
           
            }
            catch (FormatException /* ex */)
            {
                ds = null;
            }

            
            if (ds == null || ds.Tables["Tarifario"].Rows.Count == 0)
            {
                txtTarifarioDescricao.Text = "";

                //
                // mostrar janela de pesquisa
                //
                TarifarioPesquisaForm tp = new TarifarioPesquisaForm();
                if (tp.ShowDialog() == DialogResult.OK)
                {
                    ds = t.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, tp.TarifarioID);
                    txtTarifarioDescricao.Text = (string)ds.Tables["TarifarioDetalhe"].Rows[0]["Descricao"];
                    
                    txtTarifarioID.Text = tp.TarifarioID.ToString();

                    _comissao = int.Parse((ds.Tables["TarifarioDetalhe"].Rows[0]["Comissao"]).ToString());
                }
            }
            else
            {
                //
                // mostrar nome do cliente
                //
                txtTarifarioDescricao.Text = (string)ds.Tables["Tarifario"].Rows[0]["Descricao"];
            }		

        }

    }
}