﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class CartaoPesquisaForm : Form
    {
        public CartaoPesquisaForm()
        {
            InitializeComponent();
        }

        private int _cartao;
        public int Cartao
        {
            get { return _cartao; }
        }



        private void btnProcurar_Click(object sender, EventArgs e)
        {
            if (txtNumero.Text.Trim().Length == 0)
                txtNumero.Text = "%";

            //
            // procurar os cartões
            //
            ICartao c = Fabrica.CreateCartaoService();
            DataSet ds = c.GetInfoByNumero(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, txtNumero.Text);

            //
            // efectuar databind
            //
            dgCartoes.DataMember = "Cartao";
            dgCartoes.DataSource = ds;

            //
            // permitir selecção
            //
            btnOk.Enabled = (ds.Tables["Cartao"].Rows.Count != 0);
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            if (dgCartoes.DataSource != null)
            {
                //
                // obter registo seleccionado na datagrid
                //

                //Get the Currency Manager by using the BindingContext of the DataGrid
                CurrencyManager cm = (CurrencyManager)this.BindingContext[dgCartoes.DataSource, dgCartoes.DataMember];

                //Retrieve the default DataView of the DataGrid
                DataView dv = (DataView)cm.List;

                // Use Currency Manager and DataView to retrieve the Current Row
                DataRow dr = dv[cm.Position].Row;

                this._cartao = (int)dr["CartaoID"];

                this.DialogResult = DialogResult.OK;
            }
        }

          }
}