﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;

using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class ChamadaForm : Form
    {
        private IChamada registoChamadas;
        public ChamadaForm()
        {
            InitializeComponent();
        }

        private void ChamadaForm_Load(object sender, EventArgs e)
        {
            registoChamadas = Fabrica.CreateChamadaService();

        }

        private void btnIniciar_Click(object sender, EventArgs e)
        {
            PhonicsStatusEnum ret = registoChamadas.Iniciar(UtilizadorDefenicoes.Username,UtilizadorDefenicoes.Password, int.Parse(txtCartaoID.Text.ToString()), int.Parse(txtNumeroOrigem.Text.ToString()), int.Parse(txtNumeroDestino.Text.ToString()), (DateTime)dtpData.Value);
        }

        private void btnTerminar_Click(object sender, EventArgs e)
        {
          
            ICartao c = Fabrica.CreateCartaoService();
            DataSet dsc = c.GetInfoByNumero(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, txtNumeroOrigem.Text);
            int tarifarioID = (int)dsc.Tables["Cartao"].Rows[0]["TarifarioID"];
            ITarifario t = Fabrica.CreateTarifarioService();
            DataSet dst = t.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, tarifarioID);
          
            PhonicsStatusEnum ret = registoChamadas.Finalizar(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, int.Parse(txtNumeroOrigem.Text.ToString()));
          
        }

        private void btnTempo_Click(object sender, EventArgs e)
        {
            int nsegundos;
            PhonicsStatusEnum ret = registoChamadas.GetSegundos(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, int.Parse(txtNumeroOrigem.Text), out nsegundos);
            if (ret == PhonicsStatusEnum.OK) lbTempo.Text = nsegundos.ToString();
            else MessageBox.Show(ret.ToString(), "Resultado Mostrar");
        }

        private void btnChamadas_Click(object sender, EventArgs e)
        {
            DataSet d;
            PhonicsStatusEnum ret = registoChamadas.GetChamadasActivas(UtilizadorDefenicoes.Username,UtilizadorDefenicoes.Password, out d);

            dgChamadas.DataSource = d;
            dgChamadas.DataMember = "Table";
        }

        private void btnCartaoIDPesquisar_Click(object sender, EventArgs e)
        {
            //
            // pesquisar pelo código introduzido 
            ICartao c = Fabrica.CreateCartaoService();
            DataSet ds = null;
            try
            {
                ds = c.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, int.Parse(txtCartaoID.Text));
            }
            catch (FormatException /* ex */)
            {
                ds = null;
            }
            if (ds == null || ds.Tables["Cartao"].Rows.Count == 0)
            {
                txtNumeroOrigem.Text = "";

                //
                // mostrar janela de pesquisa
                //
                CartaoPesquisaForm cp = new CartaoPesquisaForm();
                if (cp.ShowDialog() == DialogResult.OK)
                {
                    ds = c.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, cp.Cartao);
                    txtNumeroOrigem.Text = (string)ds.Tables["Cartao"].Rows[0]["Numero"].ToString();
                    txtCartaoID.Text = cp.Cartao.ToString();
                }
            }
            else
            {
                //
                // mostrar nome do cliente
                //
                txtNumeroOrigem.Text = ds.Tables["Cartao"].Rows[0]["Numero"].ToString();


                //
                // mostrar janela de pesquisa
                //
                CartaoPesquisaForm cp = new CartaoPesquisaForm();
                if (cp.ShowDialog() == DialogResult.OK)
                {
                    ds = c.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, cp.Cartao);
                    txtNumeroOrigem.Text = (string)ds.Tables["Cartao"].Rows[0]["Numero"].ToString();
                    txtCartaoID.Text = cp.Cartao.ToString();
                }



            }		
        }

        private void btnRegistar_Click(object sender, EventArgs e)
        {
           ChamadasRegistoForm chamadaregisto = new ChamadasRegistoForm();
            


            if (chamadaregisto.ShowDialog() == DialogResult.OK)
            {
                //
                // actualizar os dados
                //
                DataRow r = chamadaregisto.Chamada;
                PhonicsStatusEnum st;
                IChamada c = Fabrica.CreateChamadaService();
                st = c.Registar(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, (int)r["cartaoID"], (int)r["numerodestino"], chamadaregisto.Inicio, chamadaregisto.Fim);
            }



        }

        
    }
}