﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;

using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class ChamadasRegistoForm : Form
    {
        public ChamadasRegistoForm()
        {
            InitializeComponent();
        }


        private DataRow _chamada;
        public DataRow Chamada
        {
            set { _chamada = value; }
            get { return _chamada; }
        }

        public DateTime _inicio;
        public DateTime Inicio
        {
            set { _inicio = value; }
            get { return _inicio; }
        }

        public DateTime _fim;
        public DateTime Fim
        {
            set { _fim = value; }
            get { return _fim; }
        }


        private void btnRegistar_Click(object sender, EventArgs e)
        {
            _chamada["cartaoID"] = int.Parse(txtCartaoID.Text.ToString());
            _chamada["numerodestino"] = txtnumerodestino.Text.ToString();
            _inicio = dtpInicial.Value;
            _fim = dtpFinal.Value;



            this.DialogResult = DialogResult.OK;
        }

        private void btnPesquisar_Click(object sender, EventArgs e)
        {
            //
            // pesquisar pelo código introduzido 
            //
            ICartao c = Fabrica.CreateCartaoService();
            DataSet ds = null;
            try
            {
                ds = c.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, int.Parse(txtCartaoID.Text));
            }
            catch (FormatException /* ex */)
            {
                ds = null;
            }
            if (ds == null || ds.Tables["Cartao"].Rows.Count == 0)
            {
                txtNumero.Text = "";

                //
                // mostrar janela de pesquisa
                //
                CartaoPesquisaForm cp = new CartaoPesquisaForm();
                if (cp.ShowDialog() == DialogResult.OK)
                {
                    ds = c.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, cp.Cartao);
                    txtNumero.Text = (string)ds.Tables["Cartao"].Rows[0]["Numero"].ToString();
                    txtCartaoID.Text = cp.Cartao.ToString();
                }
            }
            else
            {
                //
                // mostrar nome do cliente
                //
                txtNumero.Text = (string)ds.Tables["Cartao"].Rows[0]["Numero"];

            }		
        }

        private void ChamadasRegistoForm_Load(object sender, EventArgs e)
        {
            IChamada c = Fabrica.CreateChamadaService();
            DataSet ds = c.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, -1);
            _chamada = ds.Tables[0].NewRow();

            lbDataInicial.Text = dtpInicial.Value.Date.ToShortDateString();
            lbDataFinal.Text = dtpFinal.Value.Date.ToShortDateString();
        }

        private void dtpInicial_ValueChanged(object sender, EventArgs e)
        {
            lbDataInicial.Text = dtpInicial.Value.ToShortDateString();
        }

        private void dtpFinal_ValueChanged(object sender, EventArgs e)
        {
            lbDataFinal.Text = dtpFinal.Value.Date.ToShortDateString();
        }
    }
}