﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class ClienteForm : Form
    {
        public ClienteForm()
        {
            InitializeComponent();
        }

        private void btnClienteInserir_Click(object sender, EventArgs e)
        {
           
            //
            // mostar UI para actualizar os dados
            //
            ClienteInserirForm clienteinserir = new ClienteInserirForm();
            if (clienteinserir.ShowDialog() == DialogResult.OK)
            {
                //
                // actualizar os dados
                //
                DataRow r = clienteinserir.Cliente;
                PhonicsStatusEnum st;
                ICliente c = Fabrica.CreateClienteService();
                int id = c.Inserir(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, (string)r["nome"], (int)r["BI"], (string)r["morada"], (string)r["eMail"],  out st);
                if (st != PhonicsStatusEnum.OK)
                    MessageBox.Show("Aconteceu um problema ao actualizar a BD", "PhonicsWindowsApplication", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


            private void ActualizarDataGridClientes(int clienteIDaSelecionar, string filtro)
		{
			if (filtro != null)
				txtNome.Text = filtro;
			else
			{
				if (txtNome.Text.Trim().Length == 0)
					txtNome.Text = "%";
			}		

			//
			// procurar os clientes
			//
			ICliente c = Fabrica.CreateClienteService();
			DataSet ds = c.FindByName(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, txtNome.Text);
			
			//
			// efectuar databind
			//
			dgClientes.DataMember = "Cliente";
			dgClientes.DataSource = ds;

			//
			// seleccionar a linha que contém o cliente pedido
			//
			if (clienteIDaSelecionar > 0)
			{
				//Get the Currency Manager by using the BindingContext of the DataGrid
				CurrencyManager cm = (CurrencyManager)this.BindingContext[dgClientes.DataSource, dgClientes.DataMember];
                
				//Retrieve the default DataView of the DataGrid
				DataView dv = (DataView)cm.List;
				
				string oldSortExpr = dv.Sort;
				dv.Sort = "ClienteID";
				int idx = dv.Find(clienteIDaSelecionar);
				dv.Sort = oldSortExpr;
              
			}
        }

        private void btnProcurar_Click(object sender, EventArgs e)
        {
            ActualizarDataGridClientes(-1, null);
        }

        private void btnSair_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnClienteUpdate_Click(object sender, EventArgs e)
        {
            if (dgClientes.DataSource != null)
            {
                //
                // obter registo seleccionado na datagrid
                //

                //Get the Currency Manager by using the BindingContext of the DataGrid
                CurrencyManager cm = (CurrencyManager)this.BindingContext[dgClientes.DataSource, dgClientes.DataMember];

                //Retrieve the default DataView of the DataGrid
                DataView dv = (DataView)cm.List;

                // Use Currency Manager and DataView to retrieve the Current Row
                DataRow dr = dv[cm.Position].Row;

                //
                // mostar UI para actualizar os dados
                //
                ClienteInserirForm clienteinserir = new ClienteInserirForm();
                clienteinserir.Cliente = dr;
                if (clienteinserir.ShowDialog() == DialogResult.OK)
                {
                    //
                    // actualizar os dados
                    //
                    DataRow r = clienteinserir.Cliente;
                 
                    ICliente c = Fabrica.CreateClienteService();
                    PhonicsStatusEnum st = c.Update(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, (int)r["ClienteID"], (string)r["morada"], (string)r["eMail"]);
                    if (st != PhonicsStatusEnum.OK)
                        MessageBox.Show("Aconteceu um problema ao actualizar a BD: " + st, "Phonics", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void ClienteForm_Load(object sender, EventArgs e)
        {
            btnClienteUpdate.Enabled = false;
        }

        private void dgClientes_MouseClick(object sender, MouseEventArgs e)
        {
            btnClienteUpdate.Enabled = true;
        }
    }
}