﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;




using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class ClienteInserirForm : Form
    {
        public ClienteInserirForm()
        {
            InitializeComponent();
        }


        private DataRow _cliente;
        public DataRow Cliente
        {
            set { _cliente = value; }
            get { return _cliente; }
        }


        private void btnOk_Click(object sender, EventArgs e)
        {
            // copiar valores eliminando espaços em branco
            _cliente["nome"] = txtNome.Text.Trim();
            _cliente["BI"] = txtBI.Text.Trim();
            _cliente["morada"] = txtMorada.Text.Trim();
            _cliente["eMail"] = txtEmail.Text.Trim();

            this.DialogResult = DialogResult.OK;
        }

        private void ClienteInserirForm_Load(object sender, EventArgs e)
        {
            if (_cliente == null)
            {
               
                ICliente c = Fabrica.CreateClienteService();
                DataSet ds = c.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, -1);
                _cliente = ds.Tables[0].NewRow(); 
               
            }
            else
            {
                txtNome.Enabled = false;
                txtBI.Enabled = false;
                txtNome.Text = (string)_cliente["nome"];
                if (!_cliente.IsNull("BI"))
                    txtBI.Text =(_cliente["BI"]).ToString();
                if (!_cliente.IsNull("morada"))
                    txtMorada.Text = (string)_cliente["morada"];
                if (!_cliente.IsNull("eMail"))
                    txtEmail.Text = (string)_cliente["eMail"];
               
            }

        }
    }
}