﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class ClientePesquisaForm : Form
    {
        public ClientePesquisaForm()
        {
            InitializeComponent();
        }

        private int _cliente;
        public int ClienteID
        {
            get { return _cliente; }
        }

        private void Procurar_Click(object sender, EventArgs e)
        {
            if (txtNome.Text.Trim().Length == 0)
                txtNome.Text = "%";

            //
            // procurar os clientes
            //
            ICliente c = Fabrica.CreateClienteService();
            DataSet ds = c.FindByName(UtilizadorDefenicoes.Username,UtilizadorDefenicoes.Password, txtNome.Text);

            //
            // efectuar databind
            //
            dgClientes.DataMember = "Cliente";
            dgClientes.DataSource = ds;

            //
            // permitir selecção
            //
            btnOk.Enabled = (ds.Tables["Cliente"].Rows.Count != 0);
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            if (dgClientes.DataSource != null)
            {
                //
                // obter registo seleccionado na datagrid
                //

                //Get the Currency Manager by using the BindingContext of the DataGrid
                CurrencyManager cm = (CurrencyManager)this.BindingContext[dgClientes.DataSource, dgClientes.DataMember];

                //Retrieve the default DataView of the DataGrid
                DataView dv = (DataView)cm.List;

                // Use Currency Manager and DataView to retrieve the Current Row
                DataRow dr = dv[cm.Position].Row;

                this._cliente = (int)dr["ClienteID"];

                this.DialogResult = DialogResult.OK;
            }
        }

        private void ClientePesquisaForm_Load(object sender, EventArgs e)
        {

        }
    }
}