﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;

using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class TarifarioForm : Form
    {
        public TarifarioForm()
        {
            InitializeComponent();
        }

        private void TarifarioForm_Load(object sender, EventArgs e)
        {
          

            //
            // obter dados
            //
            ITarifario t = Fabrica.CreateTarifarioService();
            DataSet ds = t.GetAll(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password);

            //
            // efectuar databind
            //
            dgTarifario.DataMember = "Tarifario";
            dgTarifario.DataSource = ds;
           
        }

       

        private void btnSair_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnTarifarioInserir_Click(object sender, EventArgs e)
        {
            TarifarioInserirForm tarifarioinserir = new TarifarioInserirForm(0);
            tarifarioinserir.ShowDialog();           
        }

        private void btnTarifarioUpdate_Click(object sender, EventArgs e)
        {
            if (dgTarifario.DataSource != null)
            {
                //
                // obter registo seleccionado na datagrid
                //

                //Get the Currency Manager by using the BindingContext of the DataGrid
                CurrencyManager cm = (CurrencyManager)this.BindingContext[dgTarifario.DataSource, dgTarifario.DataMember];

                //Retrieve the default DataView of the DataGrid
                DataView dv = (DataView)cm.List;

                // Use Currency Manager and DataView to retrieve the Current Row
                DataRow dr = dv[cm.Position].Row;

                //
                // mostar UI para actualizar os dados
                //
                DataSet ds;
                ITarifario t = Fabrica.CreateTarifarioService();
                ds = t.GetInfoByID(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, (int)dr["tarifarioID"]);

                TarifarioInserirForm tarifarioinserir = new TarifarioInserirForm(1);
                tarifarioinserir.Tarifario = dr;
                tarifarioinserir.TarifarioDS = ds;
                if (tarifarioinserir.ShowDialog() == DialogResult.OK)
                {
                    //
                    // actualizar os dados
                    //
                    DataRow r = tarifarioinserir.Tarifario;

                    
                    PhonicsStatusEnum st = t.Update(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, (int)r["TarifarioID"], (string)r["descricao"], RedeEnum.OPTIMUS, DiasEnum.DIAS_UTEIS, DateTime.Now, DateTime.Now, float.Parse(r["custo"].ToString()), int.Parse(r["periodo"].ToString()), float.Parse(r["comissao"].ToString()));
                    if (st != PhonicsStatusEnum.OK)
                        MessageBox.Show("Aconteceu um problema ao actualizar a BD: " + st, "Phonics", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }


        
    }
}