﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;


using System.Data.OleDb;
using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class TarifarioInserirForm : Form
    {
        int opcao;
        public TarifarioInserirForm()
        {
            InitializeComponent();
        }

        public TarifarioInserirForm(int op)
        {
            InitializeComponent();
            opcao=op;
        }

        private DataRow _tarifario;
        public DataRow Tarifario
        {
            set { _tarifario = value; }
            get { return _tarifario; }
        }

        private DataSet _tarifarioDS;
        public DataSet TarifarioDS
        {
            set { _tarifarioDS = value; }
            get { return _tarifarioDS; }
        }



        private void dpHoraInicial_ValueChanged(object sender, EventArgs e)
        {

        }

       
        private void TarifarioInserirForm_Load(object sender, EventArgs e)
        {
            if (opcao == 0)//inserir
            {
                //
                // obter dataset em branco para as linhas da factura
                //
                ITarifario t = Fabrica.CreateTarifarioService();
                DataSet ds = t.CriarDetalhes(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password);

                // esconder as colunas que não interessam
                //             
                ds.Tables["TarifarioDetalhe"].Columns["TarifarioID"].ColumnMapping = MappingType.Hidden;


                //
                // Create a TableStyle to format the datagrid's columns. 
                //
                DataGridTableStyle tableStyle = new DataGridTableStyle();
                DataTable dtCore = ds.Tables["TarifarioDetalhe"];

                tableStyle.MappingName = "TarifarioDetalhe";

                
                //
                // Add the table style to the datagrid 
                //
                dgTarifarioDetalhes.TableStyles.Clear();
                dgTarifarioDetalhes.TableStyles.Add(tableStyle);

                //
                // efectuar databind
                //
                dgTarifarioDetalhes.Tag = ds;
                dgTarifarioDetalhes.DataMember = "TarifarioDetalhe";
                dgTarifarioDetalhes.DataSource = ds;
            }


            else
                if (opcao == 1)//update
                {
                    this.Text = "Actualizar Tarifario";
                    txtDescricao.Text = _tarifario["descricao"].ToString();
                    txtComissao.Text = _tarifario["comissao"].ToString();
                    ITarifario t = Fabrica.CreateTarifarioService();
        

                    // esconder as colunas que não interessam
                    //             
                    _tarifarioDS.Tables["TarifarioDetalhe"].Columns["TarifarioID"].ColumnMapping = MappingType.Hidden;
                    _tarifarioDS.Tables["TarifarioDetalhe"].Columns["Descricao"].ColumnMapping = MappingType.Hidden;
                    _tarifarioDS.Tables["TarifarioDetalhe"].Columns["Comissao"].ColumnMapping = MappingType.Hidden;
                    

                    //
                    // Create a TableStyle to format the datagrid's columns. 
                    //
                    DataGridTableStyle tableStyle = new DataGridTableStyle();
                    DataTable dtCore = _tarifarioDS.Tables["TarifarioDetalhe"];

                    tableStyle.MappingName = "TarifarioDetalhe";


                    //
                    // Add the table style to the datagrid 
                    //
                    dgTarifarioDetalhes.TableStyles.Clear();
                    dgTarifarioDetalhes.TableStyles.Add(tableStyle);

                    //
                    // efectuar databind
                    //
                    dgTarifarioDetalhes.Tag = _tarifarioDS;
                    dgTarifarioDetalhes.DataMember = "TarifarioDetalhe";




                    dgTarifarioDetalhes.DataSource = _tarifarioDS;
                }


        }

        private void dgTarifarioDetalhe_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void btnGravar_Click(object sender, EventArgs e)
        {
            PhonicsStatusEnum st;
            st = PhonicsStatusEnum.OK;

         
                ITarifario t = Fabrica.CreateTarifarioService();
                if(opcao==0)
                    st = t.Inserir(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password, txtDescricao.Text, float.Parse(txtComissao.Text), (DataSet)dgTarifarioDetalhes.Tag);

                if (st == PhonicsStatusEnum.DATABASE_PROBLEM)
                {
                    MessageBox.Show("Aconteceu um problema ao actualizar a BD: " + st, "Phonics", MessageBoxButtons.OK, MessageBoxIcon.Error);
        
                }
                else
                    if (st == PhonicsStatusEnum.INVALID_LOGIN)
                    {
                        MessageBox.Show("ERRO: Apenas os Supervisores podem criar um novo tarifario", "Phonics", MessageBoxButtons.OK, MessageBoxIcon.Error);
              
                    }
                    else      
                    {

                        this.Close();
                    }
           
        }
    }
}