﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using PhonicsClassLibrary;

namespace PhonicsWindowsApplication
{
    public partial class TarifarioPesquisaForm : Form
    {
        public TarifarioPesquisaForm()
        {
            InitializeComponent();
        }

        private int _tarifario;
        public int TarifarioID
        {
            get { return _tarifario; }
        }

        private void TarifarioPesquisaForm_Load(object sender, EventArgs e)
        {
            
            ITarifario t = Fabrica.CreateTarifarioService();
            DataSet ds = t.GetAll(UtilizadorDefenicoes.Username, UtilizadorDefenicoes.Password);

        
            //
            // efectuar databind
            //
            dgTarifarios.DataMember = "Tarifario";
            dgTarifarios.DataSource = ds;

            //
            // permitir selecção
            //
            btnOk.Enabled = (ds.Tables["Tarifario"].Rows.Count != 0);
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            if (dgTarifarios.DataSource != null)
            {
                //
                // obter registo seleccionado na datagrid
                //

                //Get the Currency Manager by using the BindingContext of the DataGrid
                CurrencyManager cm = (CurrencyManager)this.BindingContext[dgTarifarios.DataSource, dgTarifarios.DataMember];

                //Retrieve the default DataView of the DataGrid
                DataView dv = (DataView)cm.List;

                // Use Currency Manager and DataView to retrieve the Current Row
                DataRow dr = dv[cm.Position].Row;

                this._tarifario = (int)dr["TarifarioID"];

                this.DialogResult = DialogResult.OK;
            }
        }
    }
}